'From Smalltalk/X, Version:5.2.8 on 14-01-2008 at 02:12:09 PM'                  !

"{ Package: 'SpreadSheet:simekf1' }"

TestCase subclass:#OperatorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'obp-SpreadSheet'
!

!OperatorTests methodsFor:'testing'!

testDate
        | d d2 f i s t |

        d := Date fromDays: 5.
        d2 := Date fromDays: 365.
        f := 2.75.
        i := 4.
        s := 'foobar'.
        t := Time new setSeconds: 30.

        self assert: ((d operatorPlus: d2) isNil).
        self assert: ((d operatorPlus: f) isNil).
        self assert: ((d operatorPlus: i) = (Date fromDays: 9)).
        self assert: ((d operatorPlus: s) isNil).
        self assert: ((d operatorPlus: t) = (Date fromDays: 5)).

        self assert: ((d2 operatorMinus: d) = 360).
        self assert: ((d operatorMinus: f) isNil).
        self assert: ((d operatorMinus: i) isNil).
        self assert: ((d operatorMinus: s) isNil).
        self assert: ((d operatorMinus: t) = (Date fromDays: 4)).

        self assert: ((d operatorTimes: d2) isNil).
        self assert: ((d operatorTimes: f) isNil).
        self assert: ((d operatorTimes: i) isNil).
        self assert: ((d operatorTimes: s) isNil).
        self assert: ((d operatorTimes: t) isNil).

        self assert: ((d operatorOver: d2) isNil).
        self assert: ((d operatorOver: f) isNil).
        self assert: ((d operatorOver: i) isNil).
        self assert: ((d operatorOver: s) isNil).
        self assert: ((d operatorOver: t) isNil).

        self assert: ((d operatorNegate) isNil).
!

testFloat
        | f d f2 i s t |

        f := 3.0.
        d := Date fromDays: 365.
        f2 := 2.75.
        i := 4.
        s := 'foobar'.
        t := Time new setSeconds: 30.

        self assert: ((f operatorPlus: d) isNil).
        self assert: ((f operatorPlus: f2) = 5.75).
        self assert: ((3.5 operatorPlus: i) = 7.5).
        self assert: ((f operatorPlus: s) isNil).
        self assert: ((f operatorPlus: t) isNil).

        self assert: ((f operatorMinus: d) isNil).
        self assert: ((f operatorMinus: f2) = 0.25).
        self assert: ((2.5 operatorMinus: i) = -1.5).
        self assert: ((f operatorMinus: s) isNil).
        self assert: ((f operatorMinus: t) isNil).

        self assert: ((f operatorTimes: d) isNil).
        self assert: ((f operatorTimes: f2) = 8.25).
        self assert: ((3.75 operatorTimes: 2) = 7.5).
        self assert: ((f operatorTimes: s) isNil).
        self assert: ((f operatorTimes: t) isNil).

        self assert: ((f operatorOver: d) isNil).
        self assert: ((7.5 operatorOver: 4.0) = 1.875).
        self assert: ((f operatorOver: 6) = 0.5).
        self assert: ((f operatorOver: s) isNil).
        self assert: ((f operatorOver: t) isNil).

        self assert: ((f operatorNegate) = -3.0).
!

testSmallInteger
        | i d f i2 s t |

        i := 3.
        d := Date fromDays: 365.
        f := 2.75.
        i2 := 4.
        s := 'foobar'.
        t := Time new setSeconds: 30.

        self assert: ((i operatorPlus: d) isNil).
        self assert: ((i operatorPlus: f) = 5.75).
        self assert: ((i operatorPlus: i2) = 7).
        self assert: ((i operatorPlus: s) isNil).
        self assert: ((i operatorPlus: t) isNil).

        self assert: ((i operatorMinus: d) isNil).
        self assert: ((i operatorMinus: f) = 0.25).
        self assert: ((i operatorMinus: i2) = -1).
        self assert: ((i operatorMinus: s) isNil).
        self assert: ((i operatorMinus: t) isNil).

        self assert: ((i operatorTimes: d) isNil).
        self assert: ((i operatorTimes: f) = 8.25).
        self assert: ((i operatorTimes: i2) = 12).
        self assert: ((i operatorTimes: s) isNil).
        self assert: ((i operatorTimes: t) isNil).

        self assert: ((i operatorOver: d) isNil).
        self assert: ((i operatorOver: 1.5) = 2.0).
        self assert: ((8 operatorOver: 4) = 2).
        self assert: ((i operatorOver: s) isNil).
        self assert: ((i operatorOver: t) isNil).

        self assert: ((i operatorNegate) = -3).
!

testString
        | s d f i s2 t |

        s := 'test'.
        d := Date fromDays: 365.
        f := 2.75.
        i := 4.
        s2 := 'foobar'.
        t := Time new setSeconds: 3685.

        self assert: ((s operatorPlus: d) = 'test1902-1-1').
        self assert: ((s operatorPlus: f) = 'test2.75').
        self assert: ((s operatorPlus: i) = 'test4').
        self assert: ((s operatorPlus: s2) = 'testfoobar').
        self assert: ((s operatorPlus: t) = 'test01:01:25').

        self assert: ((s operatorMinus: d) isNil).
        self assert: ((s operatorMinus: f) isNil).
        self assert: ((s operatorMinus: i) isNil).
        self assert: ((s operatorMinus: s2) isNil).
        self assert: ((s operatorMinus: t) isNil).

        self assert: ((s operatorTimes: d) isNil).
        self assert: ((s operatorTimes: f) isNil).
        self assert: ((s operatorTimes: i) = 'testtesttesttest').
        self assert: ((s operatorTimes: s2) isNil).
        self assert: ((s operatorTimes: t) isNil).

        self assert: ((s operatorOver: d) isNil).
        self assert: ((s operatorOver: f) isNil).
        self assert: ((s operatorOver: i) isNil).
        self assert: ((s operatorOver: s2) isNil).
        self assert: ((s operatorOver: t) isNil).

        self assert: ((s operatorNegate) isNil).
!

testTime
        | t t2 d f i s |

        t := Time new setSeconds: 3685.
        t2 := Time new setSeconds: 30.
        d := Date fromDays: 5.
        f := 2.75.
        i := 4.
        s := 'foobar'.

        self assert: ((t operatorPlus: t2) = (Time new setSeconds: 3715)).
        self assert: ((t operatorPlus: d) = (Time new setSeconds: (5*3600*24+3685))).
        self assert: ((t operatorPlus: f) isNil).
        self assert: ((t operatorPlus: i) = (Time new setSeconds: 3689)).
        self assert: ((t operatorPlus: s) isNil).

        self assert: ((t operatorMinus: t2) = (Time new setSeconds: 3655)).
        self assert: ((t operatorMinus: d) isNil).
        self assert: ((t operatorMinus: f) isNil).
        self assert: ((t operatorMinus: i) = (Time new setSeconds: 3681)).
        self assert: ((t operatorMinus: s) isNil).

        self assert: ((t operatorTimes: t2) isNil).
        self assert: ((t operatorTimes: d) isNil).
        self assert: ((t operatorTimes: f) isNil).
        self assert: ((t operatorTimes: i) isNil).
        self assert: ((t operatorTimes: s) isNil).

        self assert: ((t operatorOver: t2) isNil).
        self assert: ((t operatorOver: d) isNil).
        self assert: ((t operatorOver: f) isNil).
        self assert: ((t operatorOver: i) isNil).
        self assert: ((t operatorOver: s) isNil).

        self assert: ((t operatorNegate) isNil).
! !

