"{ Encoding: utf8 }" !
"{ Package: 'SpreadSheet:simekf1' }" !

!Time methodsFor:'general operators'!

operatorPlus: arg
        ^ arg addToTime: self.
! !

!Time methodsFor:'general operators'!

operatorMinus: arg
        ^ arg subtractFromTime: self.
! !

!Time methodsFor:'general operators'!

operatorTimes: arg
        ^ arg multiplyTime: self.
! !

!Time methodsFor:'general operators'!

operatorOver: arg
        ^ arg divideTime: self.
! !

!Time methodsFor:'general operators'!

addToDate: aDate
        ^ Date fromSeconds: (aDate asSeconds + (self asSeconds)).
! !

!Time methodsFor:'general operators'!

addToNumber: aNum
        ^ nil.
! !

!Time methodsFor:'general operators'!

addToString: aStr
        ^ aStr, (self printString24HourFormat).
! !

!Time methodsFor:'general operators'!

addToTime: aTime
        ^ Time new setSeconds: (aTime asSeconds + (self asSeconds)).
! !

!Time methodsFor:'general operators'!

divideDate: aDate
        ^ nil.
! !

!Time methodsFor:'general operators'!

divideNumber: aNum
        ^ nil.
! !

!Time methodsFor:'general operators'!

divideString: aNum
        ^ nil.
! !

!Time methodsFor:'general operators'!

divideTime: aTime
        ^ nil.
! !

!Time methodsFor:'general operators'!

multiplyDate: aDate
        ^ nil.
! !

!Time methodsFor:'general operators'!

multiplyNumber: aNum
        ^ nil.
! !

!Time methodsFor:'general operators'!

multiplyString: aStr
        ^ nil.
! !

!Time methodsFor:'general operators'!

multiplyTime: aTime
        ^ nil.
! !

!Time methodsFor:'general operators'!

subtractFromDate: aDate
        ^ Date fromSeconds: (aDate asSeconds - (self asSeconds)).
! !

!Time methodsFor:'general operators'!

subtractFromNumber: aNum
        ^ nil.
! !

!Time methodsFor:'general operators'!

subtractFromString: aStr
        ^ nil.
! !

!Time methodsFor:'general operators'!

subtractFromTime: aTime
        ^ Time new setSeconds: (aTime asSeconds - (self asSeconds)).
! !

!Time methodsFor:'general operators'!

operatorNegate
        ^ nil.
! !

!Integer methodsFor:'general operators'!

addToDate:aDate 
    ^ aDate + self.
! !

!Integer methodsFor:'general operators'!

multiplyString: aString
        | res |
        res := ''.
        self timesRepeat: [res := res , aString ].
        ^ res.
! !

!Integer methodsFor:'general operators'!

addToTime:aTime 
    ^ Time new setSeconds: (aTime asSeconds + self).
! !

!Integer methodsFor:'general operators'!

multiplyTime: aTime
    ^ nil.
! !

!Integer methodsFor:'general operators'!

divideTime: aTime
    ^ nil.
! !

!Integer methodsFor:'general operators'!

subtractFromTime: aTime
    ^ Time new setSeconds: (aTime asSeconds - self).
! !

!Integer methodsFor:'converting'!

asAlphabet
        | x res |
        (self < 1) ifTrue: [^''].
        x := self + 0.
        res := ''.
        [
                x := x - 1.
                res := (Character value: ((26 asModuloNumber modulusOf: x) + 65))asString,res.
                x := x // 26.
        ] doWhile: [x>0].
        ^ res.

        "
          1 asAlphabet => 'A'
          26 asAlphabet => 'Z'
          27 asAlphabet => 'AA'
          28 asAlphabet => 'AB'
        "
! !

!Number methodsFor:'general operators'!

operatorPlus: arg
        ^ arg addToNumber: self.
! !

!Number methodsFor:'general operators'!

operatorMinus: arg
        ^ arg subtractFromNumber: self.
! !

!Number methodsFor:'general operators'!

operatorTimes: arg
        ^ arg multiplyNumber: self.
! !

!Number methodsFor:'general operators'!

operatorOver: arg
        ^ arg divideNumber: self.
! !

!Number methodsFor:'general operators'!

divideDate: aDate
        ^ nil.
! !

!Number methodsFor:'general operators'!

multiplyDate: aDate
        ^ nil.
! !

!Number methodsFor:'general operators'!

subtractFromDate: aDate
        "FIXME: this could do something else"
        ^ nil.
! !

!Number methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!Number methodsFor:'general operators'!

multiplyString: aString
       ^ nil.
! !

!Number methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!Number methodsFor:'general operators'!

addToString: aString
        ^ aString , (self asString).
! !

!Number methodsFor:'general operators'!

addToDate:aDate 
    ^ nil.
! !

!Number methodsFor:'general operators'!

operatorNegate
        ^ self negated.
! !

!Number methodsFor:'general operators'!

addToNumber: anInt
        ^ anInt + self.
! !

!Number methodsFor:'general operators'!

divideNumber: anInt
        ^ anInt / self.
! !

!Number methodsFor:'general operators'!

multiplyNumber: anInt
        ^ anInt * self.
! !

!Number methodsFor:'general operators'!

subtractFromNumber: anInt
        ^ anInt - self.
! !

!Number methodsFor:'general operators'!

addToTime:aTime 
    ^ nil.
! !

!Number methodsFor:'general operators'!

multiplyTime: aTime
    ^ nil.
! !

!Number methodsFor:'general operators'!

divideTime: aTime
    ^ nil.
! !

!Number methodsFor:'general operators'!

subtractFromTime: aTime
    ^ nil.
! !

!String methodsFor:'general operators'!

operatorPlus: anOperand
        ^ anOperand addToString: self.
! !

!String methodsFor:'general operators'!

operatorMinus: anOperand
        ^ anOperand subtractFromString: self.
! !

!String methodsFor:'general operators'!

operatorTimes: anOperand
        ^ anOperand multiplyString: self.
! !

!String methodsFor:'general operators'!

operatorOver: anOperand
        ^ anOperand divideString: self.
! !

!String methodsFor:'general operators'!

addToDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

addToString: aString
        ^ aString , self.
! !

!String methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

divideDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromDate: aDate
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!String methodsFor:'general operators'!

operatorNegate
        ^ nil.
! !

!String methodsFor:'general operators'!

addToNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

divideNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

multiplyNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromNumber: aFloat
        ^ nil.
! !

!String methodsFor:'general operators'!

addToTime:aTime 
    ^ nil.
! !

!String methodsFor:'general operators'!

multiplyTime: aTime
    ^ nil.
! !

!String methodsFor:'general operators'!

divideTime: aTime
    ^ nil.
! !

!String methodsFor:'general operators'!

subtractFromTime: aTime
    ^ nil.
! !

!Object methodsFor:'testing'!

isOperator
    "return true, if the receiver is some kind of an operator
     false is returned here - the method is only redefined in ExprOperator."

    ^ false
! !

!Object methodsFor:'accessing'!

exprPriority
        ^ 0.
! !

!Object methodsFor:'testing'!

isUnaryOperator
    "return true, if the receiver is some kind of an unary operator
     false is returned here - the method is only redefined in ExprUnOperator."

    ^ false
! !

!Date methodsFor:'general operators'!

operatorPlus: anOperand
        ^ anOperand addToDate: self.
! !

!Date methodsFor:'general operators'!

operatorMinus: anOperand
        ^ anOperand subtractFromDate: self.
! !

!Date methodsFor:'general operators'!

operatorTimes: anOperand
        ^ anOperand multiplyDate: self.
! !

!Date methodsFor:'general operators'!

operatorOver: anOperand
        ^ anOperand divideDate: self.
! !

!Date methodsFor:'general operators'!

addToDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

addToString: aString
        "FIXME: what format should we use?"
        ^ aString , self year asString , '-' , self month asString , '-' , self day asString.
! !

!Date methodsFor:'general operators'!

divideDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

divideString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

multiplyDate: aDate
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplyString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

subtractFromDate: aDate
        ^aDate - self.
! !

!Date methodsFor:'general operators'!

subtractFromString: aString
        ^ nil.
! !

!Date methodsFor:'general operators'!

operatorNegate
        ^ nil.
! !

!Date methodsFor:'general operators'!

addToNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

divideNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplyNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

subtractFromNumber: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

addToFloat: aFloat
        ^nil.
! !

!Date methodsFor:'general operators'!

addToSmallInteger: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

divideFloat: aFloat
        ^nil.
! !

!Date methodsFor:'general operators'!

divideSmallInteger: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplyFloat: aFloat
        ^nil.
! !

!Date methodsFor:'general operators'!

multiplySmallInteger: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

subtractFromFloat: aFloat
        ^nil.
! !

!Date methodsFor:'general operators'!

subtractFromSmallInteger: anInt
        ^nil.
! !

!Date methodsFor:'general operators'!

addToTime:aTime 
    ^ Time new setSeconds: (aTime asSeconds + (self asSeconds)).
! !

!Date methodsFor:'general operators'!

multiplyTime: aTime
    ^ nil.
! !

!Date methodsFor:'general operators'!

divideTime: aTime
    ^ nil.
! !

!Date methodsFor:'general operators'!

subtractFromTime: aTime
    ^ nil.
! !

